//
//  dotkey95 - Dotkey95 is One-Time KEY calculater for Windows95
//
//  Copyright(C) 1996,1997 NEC Corporation
//	All rights reserved.
//  Author(s): Mizukoshi, Yasuhiro <mizukosi@ccs.mt.nec.co.jp>
//

//	    $Archive: /sotools/dotkey95/PREFS.C $
//			$Revision: 5 $
//			$Date: 97/05/15 10:58a $
static char VssID[] = "$Header: /sotools/dotkey95/PREFS.C 5     97/05/15 10:58a Mizukosi $";


#include	<windows.h>
#include	"resource.h"
#include	"dotkey95.h"

extern Preference	pref;
extern PassCache	passcache[PASSCACHE_NUM];
extern int			PassCachePos;

//
//	Initialize Preferences
//
int InitPrefs()
{
	int i;

	pref.bWithCRLF   = TRUE;
	pref.bAutoPaste  = TRUE;
	pref.bAutoDetect = TRUE;
	pref.bPassCache  = FALSE;
	pref.iPasteCmd   = DEFAULT_PASTE;
	pref.cRotateKey  = (char)GetTickCount();

	for (i = 0; i < PASSCACHE_NUM; i++)
		passcache[i].HashFunc = -1;

	return TRUE;
}


//
//
//
BOOL LoadRegistory()
{
	HKEY  hKey;
	DWORD dwType;
	DWORD dwLength;
	DWORD dwData;

	if (RegOpenKeyEx(HKEY_CURRENT_USER, DOTKEY95_SUBKEY, 0, KEY_QUERY_VALUE, &hKey) != ERROR_SUCCESS){
		return FALSE;
	}

	dwType   = REG_DWORD;
	dwLength = sizeof(dwData);
	if (RegQueryValueEx(hKey, WITHCRLF_VALNAME, NULL, &dwType, (LPBYTE)&dwData, &dwLength) == ERROR_SUCCESS)
		pref.bWithCRLF = (BOOL)dwData;

	dwType   = REG_DWORD;
	dwLength = sizeof(dwData);
	if (RegQueryValueEx(hKey, AUTOPASTE_VALNAME, NULL, &dwType, (LPBYTE)&dwData, &dwLength) == ERROR_SUCCESS)
		pref.bAutoPaste = (BOOL)dwData;

	dwType   = REG_DWORD;
	dwLength = sizeof(dwData);
	if (RegQueryValueEx(hKey, AUTODETECT_VALNAME, NULL, &dwType, (LPBYTE)&dwData, &dwLength) == ERROR_SUCCESS)
		pref.bAutoDetect = (BOOL)dwData;

	dwType   = REG_DWORD;
	dwLength = sizeof(dwData);
	if (RegQueryValueEx(hKey, PASSCACHE_VALNAME, NULL, &dwType, (LPBYTE)&dwData, &dwLength) == ERROR_SUCCESS)
		pref.bPassCache = (BOOL)dwData;

	dwType   = REG_DWORD;
	dwLength = sizeof(dwData);
	if (RegQueryValueEx(hKey, PASTECMD_VALNAME, NULL, &dwType, (LPBYTE)&dwData, &dwLength) == ERROR_SUCCESS)
		pref.iPasteCmd = (int)dwData;

	RegCloseKey(hKey);

	return TRUE;
}

//
//
//
BOOL SaveRegistory()
{
	HKEY  hKey;
	DWORD dwType;
	DWORD dwLength;
	DWORD dwData;

	if (RegCreateKeyEx(HKEY_CURRENT_USER, DOTKEY95_SUBKEY, 0, "", REG_OPTION_NON_VOLATILE,
						KEY_WRITE, NULL, &hKey, &dwType) != ERROR_SUCCESS){
		return FALSE;
	}

	dwType   = REG_DWORD;
	dwLength = sizeof(dwData);
	dwData   = (DWORD)pref.bWithCRLF;
	RegSetValueEx(hKey, WITHCRLF_VALNAME, 0, dwType, (LPBYTE)&dwData, dwLength);

	dwType   = REG_DWORD;
	dwLength = sizeof(dwData);
	dwData   = (DWORD)pref.bAutoPaste;
	RegSetValueEx(hKey, AUTOPASTE_VALNAME, 0, dwType, (LPBYTE)&dwData, dwLength);

	dwType   = REG_DWORD;
	dwLength = sizeof(dwData);
	dwData   = (DWORD)pref.bAutoDetect;
	RegSetValueEx(hKey, AUTODETECT_VALNAME, 0, dwType, (LPBYTE)&dwData, dwLength);

	dwType   = REG_DWORD;
	dwLength = sizeof(dwData);
	dwData   = (DWORD)pref.bPassCache;
	RegSetValueEx(hKey, PASSCACHE_VALNAME, 0, dwType, (LPBYTE)&dwData, dwLength);

	dwType   = REG_DWORD;
	dwLength = sizeof(dwData);
	dwData   = (DWORD)pref.iPasteCmd;
	RegSetValueEx(hKey, PASTECMD_VALNAME, 0, dwType, (LPBYTE)&dwData, dwLength);

	RegCloseKey(hKey);

	return TRUE;
}


//
//
//
BOOL CALLBACK OptionDlgProc(HWND hDlg, UINT uMessage,
			    WPARAM wParam, LPARAM lParam)
{
    switch(uMessage) {
    case WM_INITDIALOG:
	{
		CheckDlgButton(hDlg, IDC_CRLF,       pref.bWithCRLF);
		CheckDlgButton(hDlg, IDC_AUTOPASTE,  pref.bAutoPaste);
		CheckDlgButton(hDlg, IDC_AUTODETECT, pref.bAutoDetect);
		CheckDlgButton(hDlg, IDC_PASSCACHE,  pref.bPassCache);
		CheckRadioButton(hDlg, FIRST_PASTE, LAST_PASTE, FIRST_PASTE + pref.iPasteCmd);
		break;
	}

    case WM_COMMAND:
		switch(wParam) {
		case IDOK:
		{
			int i;

			pref.bWithCRLF   = IsDlgButtonChecked(hDlg, IDC_CRLF);
			pref.bAutoPaste  = IsDlgButtonChecked(hDlg, IDC_AUTOPASTE);
			pref.bAutoDetect = IsDlgButtonChecked(hDlg, IDC_AUTODETECT);
			pref.bPassCache  = IsDlgButtonChecked(hDlg, IDC_PASSCACHE);
			for (i = FIRST_PASTE; i <= LAST_PASTE; i++){
				if (IsDlgButtonChecked(hDlg, i)){
					pref.iPasteCmd = i - FIRST_PASTE;
					break;
				}
			}

			SaveRegistory();

			EndDialog(hDlg, TRUE);
			break;
		}

		case IDCANCEL:
			EndDialog(hDlg, FALSE);
			break;

		default:
			return FALSE;
	    }
	    break;

	default:
	    return FALSE;
	}
	return TRUE;
}
